/* eslint-disable */
<template>
  <v-container>
    <v-card>
      <!-- Cabeçalho entidades -->
      <section>
        <div class="toolBar">
          <v-toolbar-title class="font-weight-bold primary--text">Entidades</v-toolbar-title>

          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
          <!-- <div class="navEntityOption"> -->
          <v-btn
            v-if="userCanCreate"
            small
            color="primary"
            class="mr-4"
            elevation="0"
            @click="openDialogCreate"
          >
            Adicionar
            <v-icon small right class="ml-3">mdi-plus</v-icon>
          </v-btn>
          <input
            ref="uploadInput"
            type="file"
            accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
            class="uploadInput"
          />
          <v-btn
            v-if="userCanImport"
            small
            color="primary"
            class="mr-4"
            elevation="0"
            @click="handleImport"
          >
            Importar
            <v-icon small right class="ml-3">mdi-file-import</v-icon>
          </v-btn>
          <v-btn v-if="userCanDownload" small color="primary" elevation="0" @click="handleDownload">
            Baixar
            <v-icon small right class="ml-3">mdi-download</v-icon>
          </v-btn>

          <v-row
            v-if="treeView"
            no-gutters
            class="justify-end align-center fill-height pr-10 pb-3 fill-width"
          >
            <v-tooltip color="blue" bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" class="mr-2" color="blue">mdi-help-circle</v-icon>
              </template>
              <span
                >Para buscar na árvore, deixe as entidades <b>pais</b> abertas
                <v-icon color="white">mdi-folder-open</v-icon></span
              >
            </v-tooltip>
            <v-col cols="6">
              <v-text-field
                v-model="searchTree"
                label="Pesquisar na árvore"
                single-line
                hide-details
              ></v-text-field>
            </v-col>
          </v-row>
          <v-row v-if="!treeView" no-gutters class="justify-end align-center fill-height">
            <v-col cols="6">
              <v-text-field
                v-model="filterText"
                label="Pesquisar por nome"
                single-line
                hide-details
              ></v-text-field>
            </v-col>
            <v-col align="end" cols="1">
              <v-tooltip color="primary" bottom>
                <template v-slot:activator="{ on }">
                  <v-btn
                    slot="activator"
                    fab
                    x-small
                    color="primary"
                    v-on="on"
                    elevation="0"
                    @click="handleFilter"
                  >
                    <v-icon small>mdi-magnify</v-icon>
                  </v-btn>
                </template>
                <span>Buscar</span>
              </v-tooltip>
            </v-col>
            <v-col cols="1">
              <v-tooltip color="red" bottom>
                <template v-slot:activator="{ on }">
                  <v-btn slot="activator" v-on="on" fab x-small color="transparent" elevation="0">
                    <v-icon color="red" @click="refresh">mdi-magnify-minus-outline</v-icon>
                  </v-btn>
                </template>
                <span><b>Remover</b> resultado busca</span>
              </v-tooltip>
            </v-col>
          </v-row>
        </div>
        <div
          v-if="haveChild && !treeView"
          style="font-size: 0.85rem"
          class="ml-4 my-2 secondary--text"
        >
          <v-icon small class="pb-1 mr-1">mdi-alert</v-icon> Exibindo todas entidades
          <b>parentes inferiores</b> ao nível hierárquico da entidade <b>({{ nameOfEntity }})</b>.
        </div>
        <v-row no-gutters justify="start" class="mr-4 mb-0">
          <v-spacer />
          <v-switch
            class="pa-0 ma-0"
            v-model="treeView"
            append-icon="mdi-file-tree"
            label="Modo Árvore"
            color="shadow"
            inset
            flat
            hide-details
          ></v-switch>
        </v-row>
        <!-- inicia v-treeview -->
        <section class="pa-5" v-if="treeView" style="overflow-x: auto;">
          <template>
            <v-treeview
              style="cursor: default !important"
              v-model="tree"
              :open.sync="initiallyOpen"
              :search="searchTree"
              :items="treeItems"
              item-key="id"
          
            >
              <template v-slot:prepend="{ item, open }">
                <div class="treeHoverNoCursor">
                  <v-icon v-if="!item.file && item.id">
                    {{ open ? 'mdi-folder-open' : 'mdi-folder' }}
                  </v-icon>
                  <v-icon v-if="!item.id" small>mdi-alert</v-icon>
                </div>
              </template>
              <template slot="label" slot-scope="{ item }">
                <div class="treeHover">
                  <span
                    v-if="item.id"
                    @click="openEntity(item)"
                    @mouseenter="idMouseEnter = item.id"
                    @mouseleave="idMouseEnter == ''"
                    :style="idMouseEnter ? 'cursor:pointer' : ''"
                  >
                    <span v-if="item.firstName">{{ item.firstName }} / </span>
                    {{ item.name }}
                  </span>
                  <span v-else>{{ item.name }}</span>
                </div>
              </template>
              <template slot="append" slot-scope="{ item }">
                <div v-if="item.id" class="entityIconsTreeView">
                  <v-tooltip v-if="userCanChangeDaughterEntities" bottom color="primary">
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" class="mx-0" small @click.self="confirmLookEntity(item)"
                        >mdi-eye</v-icon
                      >
                    </template>
                    <span class="text-center"><b>Ver</b> entidade</span>
                  </v-tooltip>
                  <v-tooltip
                    v-if="userCanChangeDaughterEntities && historyNavEntity.has(item.id) == false"
                    bottom
                    color="primary"
                  >
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" small @click.self="handleManage(item)" class="ml-4"
                        >mdi-cog</v-icon
                      >
                    </template>
                    <span class="text-center"><b>Gerenciar</b> entidades filhas</span>
                  </v-tooltip>

                  <v-tooltip
                    v-if="userCanEdit && historyNavEntity.has(item.id) == false"
                    bottom
                    color="primary"
                  >
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" small class="mx-2" @click.self="openDialogEdit(item)"
                        >mdi-pencil</v-icon
                      >
                    </template>
                    <span class="text-center"><b>Editar</b> dados da entidade</span>
                  </v-tooltip>

                  <v-tooltip
                    v-if="userCanDelete && historyNavEntity.has(item.id) == false"
                    bottom
                    color="primary"
                  >
                    <template v-slot:activator="{ on }">
                      <v-icon v-on="on" small @click.self="handleDelete(item)">mdi-delete</v-icon>
                    </template>
                    <span>Deletar</span>
                  </v-tooltip>
                </div>
              </template>
            </v-treeview>
          </template>
        </section>
      </section>
      <!-- inicia Tabela de dados -->
      <v-data-table
        v-if="!treeView"
        :headers="headers"
        :items="entities"
        :items-per-page="numberOfPages"
        hide-default-footer
        calculate-widths
        class="elevation-1 mt-2"
        :footer-props="{
          itemsPerPageText: 'Entidades por página',
        }"
      >
        <template v-slot:[`item.name`]="{ item }">
          <span v-if="item.firstName"
            ><span>{{ item.firstName }} / </span>
            {{ item.name }}
          </span>
          <span v-else>{{ item.name }}</span>
        </template>
        <template v-slot:[`item.action`]="{ item }">
          <div class="entitiesTable">
            <v-tooltip v-if="userCanChangeDaughterEntities" bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small @click="handleManage(item)">mdi-cog</v-icon>
              </template>
              <span class="text-center"><b>Gerenciar</b> entidades filhas</span>
            </v-tooltip>

            <v-tooltip v-if="userCanEdit" bottom color="primary">
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small class="mx-2" @click="openDialogEdit(item)"
                  >mdi-pencil</v-icon
                >
              </template>
              <span class="text-center"><b>Editar</b> dados da entidade</span>
            </v-tooltip>

            <v-tooltip
              v-if="userCanDelete && historyNavEntity.has(item.id) == false"
              bottom
              right
              color="primary"
            >
              <template v-slot:activator="{ on }">
                <v-icon v-on="on" small @click="handleDelete(item)">mdi-delete</v-icon>
              </template>
              <span style="white-space: nowrap">
                <span>Deletar</span>
                <span>Não</span>
              </span>
            </v-tooltip>
          </div>
        </template>
        <template v-slot:no-data>
          <span>Nenhuma entidade encontrada</span>
        </template>
      </v-data-table>
      <v-pagination
        v-if="!treeView"
        v-model="pagination.page"
        color
        class="py-3"
        :length="pages"
        @input="readEntities"
      ></v-pagination>
    </v-card>
    <v-dialog
      v-model="dialogCreate"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <EntitiesCreate
        :entities="entitiesChildren"
        :item-to-edit="itemToEdit"
        :title-dialog-create="titleDialogCreate"
        :items-modules="itemsModules"
        :dialog-entities-create="dialogCreate"
        :show-edit="showEdit"
        @closeDialogCreate="closeDialogCreate"
        @handleCreate="handleCreate"
        @handleEdit="handleEdit"
        @readEntitiesCreate="readEntities"
      />
    </v-dialog>
    <!--<EntitiesUpdate /> RETIRADO -->

    <v-dialog v-model="entitiesManageDialog.open" width="80%">
      <EntitiesManage
        v-if="entitiesManageDialog.open"
        :entity-item="entitiesManageDialog.item"
        @close="closeEntitiesManageDialog"
      />
    </v-dialog>
    <!-- Confirma deletar entidade -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDelete"
    />
    <AlertConfirm
      :alert="alert2"
      @clickCancelAlert="alert2.status = false"
      @clickConfirmAlert="lookEntity(goToEntity)"
    />
  </v-container>
</template>

<script>
import { Utils } from '../../utils/utils'
import { mapMutations, mapState } from 'vuex'
import Management from '../../services/management'
import User from '../../services/user'
import EntitiesCreate from '../../components/management/EntitiesCreate'
import EntitiesManage from '../../components/management/EntitiesManage'

export default {
  name: 'Entities',
  components: {
    EntitiesCreate,
    /*EntitiesUpdate,*/
    EntitiesManage,
  },
  data: () => ({
    searchTree: null,
    childrenDialog: false,
    idCurrentlyEntity: '',
    historyNavEntity: new Set(),
    treeView: true,
    initiallyOpen: [],
    tree: [],
    treeItems: [],
    idMouseEnter: '',
    renameRefresh: '',
    alert: {
      status: false,
      itemName: '',
      message: 'Você deseja <b>deletar</b> a entidade ',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert2: {
      status: false,
      itemName: '',
      icon: 'mdi-notebook',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    goToEntity: {},
    haveChild: false,
    showEdit: false,
    itemToEdit: {
      modules: [],
      parentId: '',
      name: '',
      firstName: '',
      visible: true,
      initialDate: '',
      endDate: '',
    },
    itemToDelete: {},
    itemToCreate: {},
    titleDialogCreate: '',
    dialogCreate: false,
    itemsModules: [],
    headers: [
      { text: 'Nome', align: 'left', sortable: false, value: 'name', width: '80%' },
      { text: 'Ações', align: 'right', value: 'action', sortable: false, width: '20%' },
    ],
    itemsEntity: [],
    entities: [],
    entitiesChildren: [],
    pagination: {
      page: 1,
      totalItems: 0,
    },
    numberOfPages: 20,
    filterText: '',
    itemTeste: [],
    userCanCreate: false,
    userCanImport: false,
    userCanDownload: false,
    userCanChangeDaughterEntities: false,
    userCanEdit: false,
    userCanDelete: false,

    //bloco de gerenciamento de entidades
    entitiesManageDialog: {
      open: false,
      item: {},
    },
  }),
  computed: {
    pages() {
      return Math.ceil(this.pagination.totalItems / this.numberOfPages)
    },
    nameOfEntity() {
      return this.$route.params.entityName
    },
  },
  watch: {
    async treeView() {
      if (!this.treeView) {
        this.searchTree = null
        await this.readEntities()
        await this.readModules()
        await this.checkHaveChild()
      } else {
        await this.initTree()
      }
    },
  },
  async created() {
    await this.userCheckPrivileges('userCanCreate', 'createEntity')
    await this.userCheckPrivileges('userCanImport', 'entitiesImport')
    await this.userCheckPrivileges('userCanDownload', 'entitiesDownload')
    await this.userCheckPrivileges('userCanChangeDaughterEntities', 'addEntityOn')
    await this.userCheckPrivileges('userCanEdit', 'updateEntity')
    await this.userCheckPrivileges('userCanDelete', 'entityDelete')
    await this.initTree()
  },
  methods: {
    ...mapMutations('user', [
      'UPDATE_ENTITIES_CREATE',
      'UPDATE_ENTITIES_UPDATE',
      'UPDATE_ENTITIES_DELETE',
    ]),
    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },
    openDialogEdit(item) {
      this.showEdit = true
      this.itemToEdit = item
      this.titleDialogCreate = 'Editar Entidade'
      this.dialogCreate = true
    },
    openDialogCreate() {
      this.titleDialogCreate = 'Adicionar Entidade'
      this.dialogCreate = true
      this.readEntityChild()
      this.readModules()
    },
    closeDialogCreate() {
      this.dialogCreate = false
      this.showEdit = false
      this.itemToEdit = {
        modules: [],
        parentId: '',
        name: '',
        firstName: '',
        visible: true,
        initialDate: '',
        endDate: '',
      }
    },
    refresh() {
      this.pagination.page = 1
      this.filterText = ''
      this.readEntities()
      this.readModules()
    },
    async checkHaveChild() {
      const entityChildren = await this.$getItem('entityChildren')
      return entityChildren.length > 0 ? (this.haveChild = true) : (this.haveChild = false)
    },
    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },

    async handleCreate(item) {
      let initial = null
      let final = null
      if (item.initialDate) {
        initial = Utils.timeConverter2(item.initialDate)
      }
      if (item.endDate) {
        final = Utils.timeConverter2(item.endDate)
      }
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('createEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.createEntity(entityId, actionId, {
          parentId: item.parentId,
          name: item.name,
          modules: item.modules,
          firstName: item.firstName,
          visible: item.visible,
          initialDate: initial,
          endDate: final,
        })
        if (ret.success) {
          this.itemToCreate = ret.data
          this.$store.commit('user/UPDATE_LOADING', false)
          this.closeDialogCreate()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Entidade <b>criada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
        if (!ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.closeDialogCreate()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não foi possível <b>criar</b> a entidade!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log('catch create role', e)
      }
      this.pagination.page = 1
      if (!this.treeView) {
        await this.readEntities()
      } else {
        await this.initTree()
      }
    },
    transformStringtoDate(dataString) {
      const partes = dataString.split('/')

      const dia = parseInt(partes[0], 10)
      const mes = parseInt(partes[1], 10) - 1
      const ano = parseInt(partes[2], 10)

      const data = new Date(ano, mes, dia)

      return data
    },
    async handleEdit(item) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id

      const initialDate = !!item.initialDate
        ? this.transformStringtoDate(item.initialDate).getTime()
        : null
      const endDate = !!item.endDate ? this.transformStringtoDate(item.endDate).getTime() : null

      const newItem = {
        ...item,
        initialDate,
        endDate,
      }
      try {
        console.log(newItem, 'entity')
        let ret = await Management.updateEntity(entityId, actionId, item.id, newItem)
        if (ret.success) {
          this.renameRefresh = ret.data.name
          this.filterToEdit(this.treeItems, this.itemToEdit.id, ret.data.name)
          this.$store.commit('user/UPDATE_LOADING', false)
          this.closeDialogCreate()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Dados da entidade <b>modificado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
        if (!ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.closeDialogCreate()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Não foi possível <b>editar</b> os dados da entidade!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log('catch create role', e)
      }
      if (!this.treeView) {
        await this.readEntities()
      }
    },
    handleDelete(item) {
      this.alert.itemName = item.name
      this.alert.status = true
      this.itemToDelete = item
    },
    async confirmDelete() {
      this.alert.status = false
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('entityDelete').id
      const removedEntityId = this.itemToDelete.id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.removeEntity(entityId, actionId, removedEntityId)
        if (ret.success) {
          this.filterToDelete(this.treeItems, this.itemToDelete.id)
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Entidade <b>deletada</b> com sucesso!',
            icon: 'mdi-delete-circle-outline',
            color: 'green',
          })
        }
      } catch (e) {
        console.log(e.response.data.data.error)
        this.$store.commit('user/UPDATE_LOADING', false)
        const error = {
          entityHasChildren: 'Erro! Entidade possui <b>entidade filha</b>.',
          entityHasUser: 'Erro! Entidade possui <b>usuário</b> cadastrado.',
          default: 'Erro! Não foi possível <b>deletar</b> a entidade.',
        }
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: error[e.response.data.data.error] ?? error.default,
          icon: 'mdi-close-circle',
          color: 'red',
        })
      } finally {
        if (!this.treeView) {
          await this.readEntities()
        }
      }
    },
    async readModules() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('readEntityByName').id
        let ret = await Management.readEntityModules(entityId, actionId)
        this.itemsModules = ret.data.filter((entity) => entity.label !== 'Gerenciamento')
      } catch (e) {
        console.error('error read modules ->', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async readEntityChild() {
      this.entitiesChildren = []
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      try {
        let ret = await User.readEntityChild(entityId)
        // await this.$setItem('entityChildren', ret.data)
        // console.log(ret.data)
        this.entitiesChildren.push(routedEntity)
        ret.data.forEach((children) => {
          this.entitiesChildren.push(children)
        })
        // this.entitiesChildren = [{ ...this.entitiesChildren }, ret.data]
        // this.UPDATE_ENTITY_CHILDREN(ret.data)
      } catch (e) {
        console.log('e', e)
      }
    },

    async readEntities() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readEntityByName').id
      const search = {
        entityId,
        page: this.pagination.page,
        skip: this.numberOfPages,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntitiesByPage(entityId, actionId, search)
        if (ret.success) {
          //código para retirar a própria entidade da lista de entidades
          let showEntities = ret.data.entities.filter((entity) => {
            if (entity.id !== entityId) return entity
          })
          //fim código

          this.entities = showEntities
          // console.log(this.entities, 'retorno inicial de entidades')
          this.pagination.totalItems = ret.data.count
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async handleImport() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('entitiesImport').id
      this.$refs.uploadInput.onchange = async (event) => {
        const file = event.target.files[0]
        const formData = new FormData()
        formData.append('entitiesDocument', file)
        try {
          this.$store.commit('user/UPDATE_LOADING', true)
          let ret = await Management.importEntities(entityId, actionId, formData)

          if (ret.success) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Entidades <b>importadas</b> com sucesso!',
              icon: 'mdi-check-circle',
              color: 'green',
            })
            if (!this.treeView) {
              await this.readEntities()
            } else {
              await this.initTree()
            }
          }

          if (!ret.success) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Não foi possível <b>importar</b> as entidades!',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        } catch (e) {
        } finally {
          this.$store.commit('user/UPDATE_LOADING', false)
        }
      }
      this.$refs.uploadInput.click()
      if (!this.treeView) {
        await this.readEntities()
      } else {
        await this.initTree()
      }
    },
    async handleDownload() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('entitiesDownload').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.downloadEntities(entityId, actionId)
        console.log('download', ret)
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async handleFilter() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, this.filterText)
        if (ret.success) {
          this.entities = ret.data.filter((entity) => {
            return entity.id !== entityId
          })
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    handleManage(item) {
      this.entitiesManageDialog = {
        open: true,
        item,
      }
    },

    closeEntitiesManageDialog() {
      this.entitiesManageDialog = {
        open: false,
        item: {},
      }
    },
    //métodos arvore
    async lerEntidadeFilhas(id) {
      const routedEntity = await this.$getItem('routedEntity')
      const parent = { id: routedEntity.id, name: routedEntity.name }
      let child
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await User.readEntityChild(id)
        if (ret.success) {
          child = ret.data
          child.sort((a, b) => {
            return a.name > b.name ? 1 : b.name > a.name ? -1 : 0
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return child
    },

    async readEntityPerId(id) {
      let entity
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readEntityByName').id
      try {
        let ret = await Management.readEntityPerId(entityId, actionId, {
          id: id,
        })
        if (ret.success) entity = ret.data
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }

      return entity
    },

    async initTree() {
      const routedEntity = await this.$getItem('routedEntity')
      this.idCurrentlyEntity = routedEntity.id // para a interface
      this.historyNavEntity.add(routedEntity.id)
      let entityTreeView = await this.lerEntidadeFilhas(this.idCurrentlyEntity)

      entityTreeView.forEach((item) => {
        if (item.children) item.children = []
      })

      let initialEntity = {
        id: routedEntity.id,
        name: routedEntity.name,
        firstName: routedEntity.firstName ? `${routedEntity.firstName}` : ``,
        children: [],
      }

      this.treeItems = [initialEntity]
      this.treeItems[0].children = [...entityTreeView]
      this.initiallyOpen = [routedEntity.id]
    },

    async openEntity(item) {
      let children = await this.lerEntidadeFilhas(item.id)
      if (children.length > 0) {
        children.forEach((item) => {
          if (item.children) item.children = []
        })
        item.children = children
        this.initiallyOpen.push(item.id)
      } else {
        let noEntity = [{ name: 'Não possui nenhuma entidade filha.' }]
        item.children = noEntity
        this.initiallyOpen.push(item.id)
      }
    },
    confirmLookEntity(item) {
      this.alert2.status = true
      this.alert2.message = 'Você deseja <b>visualizar</b> a página da entidade<br>'
      this.alert2.itemName = item.name
      this.goToEntity = item
    },
    async lookEntity(item) {
      this.alert2.status = false
      // exibição correta na interface dos icones de ver,gerenciar,editar, deletar
      if (this.historyNavEntity.has(item.id) && item.id != this.idCurrentlyEntity) {
        let copy = [...this.historyNavEntity]
        let index
        for (let i = 0; i < copy.length; i++) {
          if (copy[i] == item.id) {
            index = i
            break
          }
        }
        if (index + 1 < copy.length) {
          copy.splice(index + 1, copy.length - (index + 1))
          this.initiallyOpen = copy
          this.historyNavEntity = new Set(copy)
        } else {
          let refreshInitiallyOpen = new Set(this.initiallyOpen)
          refreshInitiallyOpen.delete(item.id)
          this.initiallyOpen = [...refreshInitiallyOpen]
          this.historyNavEntity.delete(item.id)
        }
      } else {
        this.historyNavEntity.add(item.id)
      }
      console.log(this.historyNavEntity)
      //começa logica
      this.idCurrentlyEntity = item.id
      await this.openEntity(item)
      this.$store.commit('user/UPDATE_LOADING', true)

      let checkEntity = await this.lerEntidadeFilhas(item.id)

      if (checkEntity.length > 0) await this.$setItem('entityChildren', checkEntity)
      let routedEntity = await this.$getItem('routedEntity')
      routedEntity.name = item.name
      if (item.firstName) routedEntity.firstName = item.firstName
      else routedEntity.firstName = ''
      routedEntity.id = item.id
      routedEntity._id = item.id
      routedEntity.children = item.filhas
      await this.$setItem('routedEntity', routedEntity)
      // await this.initTree();
      // this.$router.push(`/entity/${routedEntity.name}/management/entities`).catch((err) => {})
      // this.$router.push(`/entity/${routedEntity.name}/management/users`).catch((err) => {})
      this.$router.push(`/entity/${routedEntity.name}/supportResource`).catch((err) => {})
      this.$store.commit('user/UPDATE_LOADING', false)
      this.$store.commit('user/UPDATE_ALERT', {
        status: true,
        message: `Você está na entidade <b>${item.name}</b>.`,
        icon: 'mdi-alert',
        color: 'warning',
      })
    },
    // métodos para atualizar a treeview
    filterToDelete(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToDelete(item.children, id)
        return item.id != id
      })
      return r
    },
    filterToEdit(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToEdit(item.children, id)
        if (item.id == id) {
          item.name = this.renameRefresh
        }
        return item.id
      })
      return r
    },
  },
}
</script>

<style>


.uploadInput {
  display: none;
}
.v-pagination__item {
  margin: 4px !important;
}
.entitiesTable > .v-icon:hover {
  color: #ffc107;
}
.navEntityOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}
.entityIconsTreeView {
  padding-right: 1rem;
}

.entityIconsTreeView > .v-icon {
  margin-right: 2px;
}

.entityIconsTreeView > .v-icon:nth-last-child() {
  margin-right: 0px;
}

.entityIconsTreeView > .v-icon:hover {
  color: #ffc107 !important;
}

.entityIconsTreeView > .v-icon:before {
  background-color: transparent !important;
}
.v-treeview{
    min-width: max-content!important;
     min-width: -moz-max-content!important;
     min-width: -webkit-max-content!important;
    }

.v-treeview-node__label {
  padding-left: 5px;
  padding-right: 10px;
  padding-top: 3px;
}

.v-treeview-node--leaf:hover {
  background-color: #f5f5f5;
  color: #2a0845;
}

.v-treeview-node:hover /deep/ .v-icon {
  color: #2a0845 !important;
}

.v-treeview-node__prepend > .v-icon:hover {
  color: #2a0845;
}

.v-treeview-node__content:hover > .v-treeview-node__prepend > .v-icon {
  color: #2a0845 !important;
}

.v-treeview-node--click:hover {
  color: #2a0845;
  /* font-weight: 700; */
}

.treeHover:hover {
  font-weight: 600;
}

.toolBar > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.toolBar {
  padding-top: 15px;
  padding-left: 17px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  flex-wrap: wrap;
  gap: 5px;
}
</style>
